"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const fs = require("fs");

const promisify = require("util.promisify");

function _readFile(_x, _x2) {
  return _readFile2.apply(this, arguments);
}

function _readFile2() {
  _readFile2 = _asyncToGenerator(function* (p, enc) {
    return new Promise((resolve, reject) => {
      fs.readFile(p, enc, (err, contents) => {
        if (err) reject(err);else resolve(contents);
      });
    });
  });
  return _readFile2.apply(this, arguments);
}

function readFile(_x3) {
  return _readFile3.apply(this, arguments);
}

function _readFile3() {
  _readFile3 = _asyncToGenerator(function* (p) {
    return _readFile(p, "utf-8");
  });
  return _readFile3.apply(this, arguments);
}

function readFileSync(p) {
  return fs.readFileSync(p, "utf-8");
}

const writeFile = promisify(fs.writeFile);
const stat = promisify(fs.stat);

function isFile(_x4) {
  return _isFile.apply(this, arguments);
}

function _isFile() {
  _isFile = _asyncToGenerator(function* (p) {
    try {
      return (yield stat(p)).isFile();
    } catch (e) {
      return false;
    }
  });
  return _isFile.apply(this, arguments);
}

function isFileSync(p) {
  try {
    return fs.statSync(p).isFile();
  } catch (e) {
    return false;
  }
}

function isDirectory(_x5) {
  return _isDirectory.apply(this, arguments);
}

function _isDirectory() {
  _isDirectory = _asyncToGenerator(function* (p) {
    try {
      return (yield stat(p)).isDirectory();
    } catch (e) {
      return false;
    }
  });
  return _isDirectory.apply(this, arguments);
}

function isDirectorySync(d) {
  try {
    return fs.statSync(d).isDirectory();
  } catch (e) {
    return false;
  }
}

const readdir = promisify(fs.readdir);
module.exports = {
  readFileSync,
  readdirSync: fs.readdirSync,
  readFile,
  writeFile,
  stat,
  isFile,
  isFileSync,
  isDirectory,
  isDirectorySync,
  readdir
};